import os, xbmc, xbmcaddon

#########################################################
### Global Variables ####################################
#########################################################
PATH           = xbmcaddon.Addon().getAddonInfo('path')
ART            = os.path.join(PATH, 'resources', 'art')
#########################################################

#########################################################
### User Edit Variables #################################
#########################################################
ADDON_ID       = xbmcaddon.Addon().getAddonInfo('id')
ADDONTITLE     = 'Wortownstreams Wizard'
BUILDERNAME    = 'Kodiskills'
EXCLUDES       = [ADDON_ID, 'repository.wortownstreams']
# Enable/Disable the text file caching with 'Yes' or 'No' and age being how often it rechecks in minutes
CACHETEXT      = 'Yes'
CACHEAGE       = 30
# Text File with build info in it.
BUILDFILE      = 'http://www.wortownstreams.com/wizard/texts/builds.txt'
# How often you would like it to check for build updates in days
# 0 being every startup of kodi
UPDATECHECK    = 2
# Text File with apk info in it.  Leave as 'http://' to ignore
APKFILE        = 'http://www.wortownstreams.com/apks/'
# Text File with Youtube Videos urls.  Leave as 'http://' to ignore
YOUTUBETITLE   = ''
YOUTUBEFILE    = 'http://'
# Text File for addon installer.  Leave as 'http://' to ignore
ADDONFILE      = 'http://'
# Text File for advanced settings.  Leave as 'http://' to ignore
ADVANCEDFILE   = 'http://'
#########################################################

#########################################################
### Theming Menu Items ##################################
#########################################################
# If you want to use locally stored icons the place them in the Resources/Art/
# folder of the wizard then use os.path.join(ART, 'imagename.png')
# do not place quotes around os.path.join
# Example:  ICONMAINT     = os.path.join(ART, 'mainticon.png')
#           ICONSETTINGS  = 'http://aftermathwizard.net/repo/wizard/settings.png'
# Leave as http:// for default icon
ICONBUILDS     = 'http://www.wortownstreams.com/wizard/images/icon'
ICONMAINT      = 'http://www.wortownstreams.com/wizard/images/maintenance.png'
ICONSPEED      = os.path.join(ART, 'speed.png')
ICONAPK        = 'http://www.wortownstreams.com/wizard/images/apkinstaller.png'
ICONADDONS     = 'http://www.wortownstreams.com/wizard/images/addoninstaller.png'
ICONYOUTUBE    = 'http://www.wortownstreams.com/wizard/images/youtube.png'
ICONSAVE       = 'http://www.wortownstreams.com/wizard/images/savedata.png'
ICONTRAKT      = 'http://www.wortownstreams.com/wizard/images/trakt.png'
ICONREAL       = 'http://www.wortownstreams.com/wizard/images/realdebrid.png'
ICONLOGIN      = 'http://www.wortownstreams.com/wizard/images/login.png'
ICONCONTACT    = 'http://www.wortownstreams.com/wizard/images/contactus.png'
ICONSETTINGS   = 'http://www.wortownstreams.com/wizard/images/settings.png'
# Hide the section seperators 'Yes' or 'No'
HIDESPACERS    = 'No'
# Character used in seperator
SPACER         = '='

# You can edit these however you want, just make sure that you have a %s in each of the
# THEME's so it grabs the text from the menu item
COLOR1         = 'dodgerblue'
COLOR2         = 'white'
# Primary menu items   / %s is the menu item and is required
THEME1         = '[COLOR '+COLOR1+'][B][I]([COLOR '+COLOR2+']Wortownstreams[/COLOR])[/I][/B][/COLOR] [COLOR '+COLOR2+']%s[/COLOR]'
# Build Names          / %s is the menu item and is required
THEME2         = '[COLOR '+COLOR2+']%s[/COLOR]'
# Alternate items      / %s is the menu item and is required
THEME3         = '[COLOR '+COLOR1+']%s[/COLOR]'
# Current Build Header / %s is the menu item and is required
THEME4         = '[COLOR '+COLOR1+']Current Build:[/COLOR] [COLOR '+COLOR2+']%s[/COLOR]'
# Current Theme Header / %s is the menu item and is required
THEME5         = '[COLOR '+COLOR1+']Current Theme:[/COLOR] [COLOR '+COLOR2+']%s[/COLOR]'

# Message for Contact Page
# Enable 'Contact' menu item 'Yes' hide or 'No' dont hide
HIDECONTACT    = 'No'
# You can add \n to do line breaks
CONTACT        = 'Thank you for choosing Wortownstreams Wizard.\r\n\r\nContact us on facebook at https://www.facebook.com/groups/1921545907919501/'
#Images used for the contact window.  http:// for default icon and fanart
CONTACTICON    = 'http://www.wortownstreams.com/wizard/images/icon'
CONTACTFANART  = 'http://www.wortownstreams.com/wizard/images/fanart'
#########################################################

#########################################################
### Auto Update                   #######################
###        For Those With No Repo #######################
#########################################################
# Enable Auto Update 'Yes' or 'No'
AUTOUPDATE     = 'No'
# Url to wizard version
WIZARDFILE     = 'http://www.wortownstreams.com/wizard/texts/builds.txt'
#########################################################

#########################################################
### Auto Install                 ########################
###        Repo If Not Installed ########################
#########################################################
# Enable Auto Install 'Yes' or 'No'
AUTOINSTALL    = 'Yes'
# Addon ID for the repository
REPOID         = 'repository.wortownstreams'
# Url to Addons.xml file in your repo folder(this is so we can get the latest version)
REPOADDONXML   = 'https://raw.githubusercontent.com/kodiskills/repository.wortownstreams/master/zips/addons.xml'
# Url to folder zip is located in
REPOZIPURL     = 'https://raw.githubusercontent.com/kodiskills/repository.wortownstreams/master/zips/repository.wortownstreams/'
#########################################################

#########################################################
### Notification Window #################################
#########################################################
# Enable Notification screen Yes or No
ENABLE         = 'Yes'
# Url to notification file
NOTIFICATION   = 'http://'
# Use either 'Text' or 'Image'
HEADERTYPE     = 'Image'
# Font size of header
FONTHEADER     = 'Font14'
HEADERMESSAGE  = '[B][COLOR dodgerblue]Wortownstreams[/COLOR][/B] Wizard'
# url to image if using Image 424x180
HEADERIMAGE    = 'http://www.wortownstreams.com/wizard/images/icon'
# Font for Notification Window
FONTSETTINGS   = 'Font13'
# Background for Notification Window
BACKGROUND     = 'http://'
#########################################################
